
#include	<stdio.h>
#include	<sys/time.h>

#include	<pcap.h>

static int	count = 0;

void do_one_packet(u_char *user, const struct pcap_pkthdr *h, const u_char *p);
void fmt_packet(int count, const u_char *pkt);

int
main(int argc, char *argv[])
{
    char		errbuf[PCAP_ERRBUF_SIZE];
    pcap_t		*p;
    struct timeval	tv;

    if (argc != 2) {
	fprintf(stderr, "usage: %s interface-name\n", argv[0]);
	exit(1);
    }
    errbuf[0] = '\0';
    if ((p = pcap_open_live(argv[1], 1500, 1, 500, errbuf)) == NULL) {
	fprintf(stderr, "open_offline: %s\n", errbuf);
	exit(1);
    }
    if (strlen(errbuf) != 0) {
	fprintf(stderr, "WARNING: %s\n", errbuf);
    }

    while (1) {
	pcap_dispatch(p, -1, do_one_packet, NULL);
	gettimeofday(&tv, NULL);
	fprintf(stderr, "%ld.%06ld XXX bottom %d\n", tv.tv_sec, tv.tv_usec, count);
    }
    pcap_close(p);


    exit(0);
}

void
do_one_packet(u_char *user, const struct pcap_pkthdr *h, const u_char *p)
{
    u_int	caplen = h->caplen;

    count++;
    if (caplen < 12) {
	fprintf(stderr, "Pkt too short!\n");
	exit(2);
    }
    fmt_packet(count, p);
}

void
fmt_packet(int count, const u_char *pkt)
{
    struct timeval	tv;

#ifdef	XXXQQQ
    gettimeofday(&tv, NULL);
    printf("packet %d: %ld.%06ld dst ether = %02x:%02x:%02x:%02x:%02x:%02x\n",
	   count, tv.tv_sec, tv.tv_usec, pkt[0], pkt[1], pkt[2], pkt[3], pkt[4], pkt[5]);
    printf("packet %d: %ld.%06ld src ether = %02x:%02x:%02x:%02x:%02x:%02x\n",
	   count, tv.tv_sec, tv.tv_usec, pkt[6], pkt[7], pkt[8], pkt[9], pkt[10], pkt[11]);
    printf("\n");
#endif	XXXQQQ
}
