/*
** Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
** See the file "LICENSE" at the top of the source distribution for
** full license terms.
**
** NOTICE: This file was generated by the tools of the Erlang Driver
**         toolkit.  Do not edit this file by hand unless you know
**         what you're doing!
**
*/

#ifndef __LIBPCAP_DRV_H
#define __LIBPCAP_DRV_H

/*
** Driver<->emulator communication codes (xref with top of libpcap_drv.hrl)
*/

#define _DEBUG                          0
#define _NULL                           1
#define _PCAP_OPEN_LIVE                 2
#define _PCAP_OPEN_OFFLINE              3
#define _MY_SET_IMMEDIATE               4
#define _PCAP_SETNONBLOCK               5
#define _PCAP_GETNONBLOCK               6
#define _PCAP_FINDALLDEVS               7
#define _PCAP_LOOKUPDEV                 8
#define _PCAP_LOOKUPNET                 9
#define _MY_PCAP_COMPILE                10
#define _PCAP_SETFILTER                 11
#define _MY_PCAP_FREECODE               12
#define _PCAP_NEXT                      13
#define _PCAP_DATALINK                  14
#define _PCAP_SNAPSHOT                  15
#define _PCAP_IS_SWAPPED                16
#define _PCAP_MAJOR_VERSION             17
#define _PCAP_MINOR_VERSION             18
#define _PCAP_STATS                     19
#define _PCAP_FILENO                    20
#define _PCAP_GETERR                    21
#define _PCAP_CLOSE                     22

/*
** Constants
*/


#define  MAX_BINVS      24      /* QQQ dumb const! */

/*
** descriptor_t = general state for the port
**
*/

struct descriptor {
    ErlDrvPort          port;
    unsigned short      nextxid;        /* Call txn ID for very async calls */
    pcap_t *            valmap_pcap_t[32];
    struct bpf_program *  valmap_bpf_program[32];
    /* TODO: Fill any additional struct members */
    char                todo;
};

/*
** callstate_t: asychronous call state
**
** TODO: Fill in the struct members of "i" and "o" below.
*/
typedef struct callstate {
    struct callstate    *next;
    int                 cmd;            /* call/command # */
#define XXXKEY  ((void *) 1)
    unsigned int        *key;           /* Not really used */
    void                (*invoke)(void *);
    void                (*free)(void *);
    unsigned short      xid;            /* Only used by as_control()-
                                           initiated funcs */
    int                 refc_bincount;
    ErlDrvBinary        *refc_bin[MAX_BINVS];
    /*
    ** Input & output args use a struct simply for convenient
    ** naming & grouping.  There isn't any attempt to get smart about
    ** using a union or anything like that to avoid bloating the size
    ** of these structs with the combined args of a zillion different
    ** functions.  QQQ For future use: look into the use of unions
    ** and/or different flavors of callstate_t to avoid structure bloat.
    */
    struct {
        int             __valmap_pcap_t_index;
        int             __valmap_bpf_program_index;
        unsigned long   __stash[4];
        char *          device;
        int             snaplen;
        int             promisc;
        int             to_ms;
        char *          fname;
        pcap_t *        p;
        u_int           immediate;
        int             nonblock;
        char *          str;
        int             optimize;
        bpf_u_int32     netmask;
        struct bpf_program *  fp;
    } i;
    struct {
        int             __expect;
        int             __expect_errval;
        pcap_t *        ret_pcap_t; /* XXX 1 */
        int             ret_int; /* XXX 1 */
        char *          ret_char_p; /* XXX 1 */
        struct bpf_program *  ret_bpf_program; /* XXX 1 */
        u_char *        ret_u_char; /* XXX 1 */
        char            errbuf[PCAP_ERRBUF_SIZE];
        pcap_if_t *     alldevsp;
        bpf_u_int32     netp;
        bpf_u_int32     mask;
        struct pcap_pkthdr  h;
        struct pcap_stat  ps;
    } o;
} callstate_t;

/*
** End of autogenerated code
**  script = ../../c_h_template.gsl
**  filename = libpcap.xml
**  gslgen version = 2.000 Beta 1
**  date = 2002/07/22
**  time =  0:41:42
*/

#endif  /* __LIBPCAP_DRV_H */
