%%%----------------------------------------------------------------------
%%% File    : simple1_drv.erl
%%% Summary : Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
%%%
%%%
%%% NOTICE: This file was generated by the tools of the Erlang Driver
%%%         toolkit.  Do not edit this file by hand unless you know
%%%         what you're doing!
%%%
%%% Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
%%% See the file "LICENSE" at the top of the source distribution for
%%% full license terms.
%%%
%%%----------------------------------------------------------------------

-module(simple1_drv).
-include("simple1_drv.hrl").

%% External exports
-export([start/0, shutdown/1, debug/2]).
-export([
         null/1, 
         bigendian/1, 
         doubleit/2, 
         addthem/3, 
         multthem/3, 
         foofoo/4, 
         ctime_returnhack/2, 
         ctime_time_t/2, 
         fopen/3, 
         fclose/2, 
         fread/4, 
         fread_string/4, 
         fwrite/3, 
         open/3, 
         open3/4, 
         close/2, 
         write/3, 
         read/3, 
         lstat/2
        ]).

start() ->
    {ok, Path} = load_path(),
    erl_ddll:start(),
    ok = erl_ddll:load_driver(Path, ?DRV_NAME),
    case open_port({spawn, ?DRV_NAME}, []) of
        P when port(P) ->
            {ok, P};
        Err ->
            Err
    end.

shutdown(Port) when port(Port) ->
    erlang:port_close(Port).

debug(Port, Flags) when port(Port), integer(Flags) ->
    erlang:port_command(Port, <<?S1_DEBUG, Flags:32>>),
    get_port_reply(Port).

null(Port
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_NULL>>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

bigendian(Port
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_BIGENDIAN>>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

doubleit(Port,
     X
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_DOUBLEIT,
          X:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

addthem(Port,
     X, 
     Y
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_ADDTHEM,
          X:32/integer, 
          Y:32/unsigned-integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

multthem(Port,
     X, 
     Y
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_MULTTHEM,
          X:32/integer, 
          Y:8/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

foofoo(Port,
     Foo1, 
     Foo2, 
     Foo3
        ) when port(Port) -> % TODO: Add additional constraints here
    {Foo1BinOrList, Foo1Len} = serialize_contiguously(Foo1, 0),
    {Foo2BinOrList, Foo2Len} = serialize_contiguously(Foo2, 0),
    {Foo3BinOrList, Foo3Len} = serialize_contiguously(Foo3, 0),
    B = [ <<?S1_FOOFOO,
            Foo1Len:32/integer>>,               % I/O list length
          Foo1BinOrList,
          <<
            Foo2Len:32/integer>>,               % I/O list length
          Foo2BinOrList,
          <<
            Foo3Len:32/integer>>,               % I/O list length
          Foo3BinOrList,
          <<
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

ctime_returnhack(Port,
     Thetime
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_CTIME_RETURNHACK,
          Thetime:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

ctime_time_t(Port,
     Thetime
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_CTIME_TIME_T,
          Thetime:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

fopen(Port,
     Path, 
     Fmode
        ) when port(Port) -> % TODO: Add additional constraints here
    {PathBinOrList, PathLen} = serialize_contiguously(Path, 1),
    {FmodeBinOrList, FmodeLen} = serialize_contiguously(Fmode, 1),
    B = [ <<?S1_FOPEN,
            PathLen:32/integer>>,               % I/O list length
          PathBinOrList,
          <<
            FmodeLen:32/integer>>,              % I/O list length
          FmodeBinOrList,
          <<
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

fclose(Port,
     Filep
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_FCLOSE,
          Filep:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

fread(Port,
     Size, 
     Nmemb, 
     Filep
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_FREAD,
          Size:32/integer, 
          Nmemb:32/integer, 
          Filep:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

fread_string(Port,
     Size, 
     Nmemb, 
     Filep
        ) when port(Port) -> % TODO: Add additional constraints here
    B = <<?S1_FREAD_STRING,
          Size:32/integer, 
          Nmemb:32/integer, 
          Filep:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

fwrite(Port,
     Ptr, 
     Filep
        ) when port(Port) -> % TODO: Add additional constraints here
    {PtrBinOrList, PtrLen} = serialize_contiguously(Ptr, 0),
    B = [ <<?S1_FWRITE,
            PtrLen:32/integer>>,                % I/O list length
          PtrBinOrList,
          <<
          Filep:32/integer
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

open(Port,
     Filename, 
     Flags
        ) when port(Port) -> % TODO: Add additional constraints here
    {FilenameBinOrList, FilenameLen} = serialize_contiguously(Filename, 1),
    B = [ <<?S1_OPEN,
            FilenameLen:32/integer>>,           % I/O list length
          FilenameBinOrList,
          <<
          Flags:32/integer
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

open3(Port,
     Filename, 
     Flags, 
     Mode
        ) when port(Port) -> % TODO: Add additional constraints here
    {FilenameBinOrList, FilenameLen} = serialize_contiguously(Filename, 1),
    B = [ <<?S1_OPEN3,
            FilenameLen:32/integer>>,           % I/O list length
          FilenameBinOrList,
          <<
          Flags:32/integer, 
          Mode:32/integer
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

close(Port,
     Fd
        ) when port(Port) -> % TODO: Add additional constraints here
    {valmap_fd, FdIndex} = Fd,
    B = <<?S1_CLOSE,
            FdIndex:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

write(Port,
     Fd, 
     Ptr
        ) when port(Port) -> % TODO: Add additional constraints here
    {valmap_fd, FdIndex} = Fd,
    {PtrBinOrList, PtrLen} = serialize_contiguously(Ptr, 0),
    B = [ <<?S1_WRITE,
            FdIndex:32/integer, 
            PtrLen:32/integer>>,                % I/O list length
          PtrBinOrList,
          <<
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

read(Port,
     Fd, 
     Size
        ) when port(Port) -> % TODO: Add additional constraints here
    {valmap_fd, FdIndex} = Fd,
    B = <<?S1_READ,
            FdIndex:32/integer, 
          Size:32/integer
        >>,
    erlang:port_command(Port, B),
    get_port_reply(Port).

lstat(Port,
     Path
        ) when port(Port) -> % TODO: Add additional constraints here
    {PathBinOrList, PathLen} = serialize_contiguously(Path, 1),
    B = [ <<?S1_LSTAT,
            PathLen:32/integer>>,               % I/O list length
          PathBinOrList,
          <<
        >> ],
    erlang:port_command(Port, B),
    get_port_reply(Port).

    
%%%
%%% Internal functions.
%%%

load_path() ->
    File = ?DRV_NAME ++ ".so",
    case lists:filter(fun(D) ->
                              case file:read_file_info(D ++ "/" ++ File) of
                                  {ok, _} -> true;
                                  _ -> false
                              end
                      end, code:get_path()) of
        [Dir|_] ->
            {ok, Dir};
        [] ->
            io:format("Error: ~s not found in code path
", [File]),
            {error, enoent}
    end.

get_port_reply(Port) ->
    receive
        {Port, ok} -> ok;
        {Port, M} -> throw(M);          % QQQ!
        {Port, ok, M} -> {ok, M};
        %% {Port, ok, M1, M2} -> {ok, M1, M2};
        {Port, error, Reason} -> {error, Reason}
        ;
        M -> io:format("QQQ XXX got ~w
", [M]), M
    end.

%%% QQQ io_list_len() is an extremely useful function.  BEAM has got this
%%% implemented quite efficiently in C.  It would be *fabulous* to be able
%%% to use it from Erlang via a BIF.

io_list_len(B) when binary(B) -> {B, size(B)};
io_list_len(L) when list(L) -> io_list_len(L, 0).
io_list_len([H|T], N) ->
    if
        H >= 0, H =< 255 -> io_list_len(T, N+1);
        list(H) -> io_list_len(T, io_list_len(H,N));
        binary(H) -> io_list_len(T, size(H) + N);
        true -> throw({error, partial_len, N})
    end;
io_list_len(H, N) when binary(H) -> 
    size(H) + N;
io_list_len([], N) -> 
    N.

%%% QQQ We need to make the binary thing we're passing in contiguous
%%% because the C function we're calling is expecting a single
%%% contiguous buffer.  If IOList is ["Hello, ", <<"World">>, "!"],
%%% that binary in the middle element will end up with the argument
%%% spanning three parts of an ErlIOVec.  If that happens, then we'd
%%% have to have the driver do the dirty work of putting the argument
%%% into a single contiguous buffer.  Frankly, we're lazy, and this
%%% code is short and won't be much slower than doing it in C.

serialize_contiguously(B, 0) when binary(B) ->
    {B, size(B)};
serialize_contiguously([B], 0) when binary(B) ->
    {B, size(B)};
serialize_contiguously(IOList, 1) ->
    serialize_contiguously([IOList, 0], 0);
serialize_contiguously(IOList, 0) ->
    B = list_to_binary(IOList),
    {B, size(B)}.
